; ---   
; : R1 -  
; : R0 -   

function	_puts
	mov	R12, R15	;     R12
	mov	r0, r1		;    
load_word:
	mov	r2, (r0)	;    (4-)
	load	r4, 4		;     
check_byte:
	rol	r2, 8		;    8  
	load	r3, 0xff	;   
	and	r3, r2		;    
	je	done		;   
	call	_putchar        ;    
	inc	r0, 1		;  
	dec	r4, 1		;  
	jne	check_byte	;  
	jmp	load_word	;  
done:
	clc			;  
	subc	r0, r1		;    
	mov	R15, R12	;     R12
	return			;   
end

; ---   
; : R3 -  
; : R3 -  
function	_putchar
	load			R6, 0xfffefff0	;    UART
do_poll:
	mov			R5, (R6)	;   
	rcr			R5, 1		;   BUSY  
	jc			do_poll		;    
	inc			R6, 4		;     
	mov			(R6), R3	;  
	dec			R6, 4		;     
wait:
	mov			R5, (R6)	;   
	rcr			R5, 1		;   BUSY  
	jc			wait		;    
	return					;   
end

; ---         
; : R0 -   (RCV_RDY & 0x02)
function	_uart_status
	load			R6, 0xfffefff0	;    UART
	mov			R0, (R6)	;   
	return
end

; ---      
;      
; : R0 -  
function	_getchar
	load			R6, 0xfffefff0	;    UART
do_poll:
	mov			R0, (R6)	;   
	rcr			R0, 2		;  RCV_RDY  
	jnc			do_poll		;    
	inc			R6, 4		;     
	mov			R0, (R6)	;   
	return					;   
end

; ---    
; : R0 -      
function	_print_hex
	mov	R12, R15	;     R12
	load		R3, 0x20
	call		_putchar
	load		R7, 0x9
fullnum:
	dec		R7
	je		finish
	load		r4, 0x9
	load		R1, 0xf
	rol		r0, 4
	and		r1, r0
	cmp		r4, r1
	jc		alphachar
	load		r3, 0x30
	addc		r3, r1
	call		_putchar
	jmp		fullnum
alphachar:
	clc
	load		r3, 0x37 		; 'A' - 0xa
	addc		r3, r1
	call		_putchar
	jmp		fullnum
finish:
	load		R3, 0x20
	call		_putchar
	mov	R15, R12	;     R12
	return
end

; ---   
function	_newline
	mov		R12, R15	;     R12
	load		R3, 0x0d
	call		_putchar
	load		R3, 0x0a
	call		_putchar
	mov		R15, R12	;     R12
	return
end
