;
; Cyborg user demo

function   user_demo
	push	r15		;      R15  
	lea	r1, $demo_str	;     R1
	call	_puts		;    UART

; ------------------------------------------------------------------

lab_show_mem_dump:
	load	r9, 80
	load	r8, 0x0
loop_shm:
	mov	r0, (r8)
	call	_print_hex 
	inc	r8, 4
	dec	r9
	jne	loop_shm
	
; ------------------------------------------------------------------

	lea	r1, $id_str	; 
	call	_puts		;    UART
	taskid			;   R0   
	call	_print_hex 
	call	_newline

; ------------------------------------------------------------------

	idle

; ------------------------------------------------------------------

	pop	r15		;      R15  
	return			; 
end

include		tty.asm

$demo_str	db	'Dumping 80 words from address 0x0000000:',13,10,0
$id_str		db	'Current task ID: ',0


